﻿using System.Collections.Generic;
using Microsoft.FSharp.Collections;

namespace PlusOne.Collections
{
	public class ImmutableList<T>
	{
		private readonly FSharpList<T> innerList;

		private ImmutableList(FSharpList<T> list)
		{
			innerList = list;
		}

		public ImmutableList()
		{
			innerList = FSharpList<T>.Empty;
		}

		public IEnumerable<T> AsEnumerable
		{
			get
			{
				return innerList;
			}
		}

		public ImmutableList<T> Cons(T item)
		{
			return ListModule.Append(innerList, FSharpList<T>.Cons(item, FSharpList<T>.Empty));
		}

		public ImmutableList<T> Concat(ImmutableList<T> other)
		{
			return new ImmutableList<T>(ListModule.Append(innerList, other));
		}

		public static implicit operator FSharpList<T>(ImmutableList<T> list)
		{
			return list.innerList;
		}

		public static implicit operator ImmutableList<T>(FSharpList<T> list)
		{
			return new ImmutableList<T>(list);
		}
	}
}